#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <iostream>
#include <cassert>

using namespace std;

typedef long long llint;
typedef pair<int, int> pii;

double sqr(double val) {
  return val * val;
}

double tf, vf, hf, td, vd, hd;

double solve(double a, double b, double c) {
  double det = b*b - 4 * a * c;
  if(det < 0) return -1;
  double x1 = (-b + sqrt(det)) / (2 * a);
  double x2 = (-b - sqrt(det)) / (2 * a);
  double sol = min(x1, x2);
  //if(sol < td) {
  //  sol = x1 + x2 - sol;
  //} else {
  //  return sol;
  //}

  //if(sol < td) return -1;

  assert(sol  > 0 );
  return sol;
}

bool can(double t) {
  double tff = tf + sqrt(2 * hf);
  if(t < tff) tff = t;
  double xf = (tff - tf) * vf;
  double yf = hf - 0.5 * sqr(tff - tf);
  if(xf - vd * (t - td) > 0) return -1;
  double vyd = sqrt(6 * hd);
  double tdy = solve(1.5, -vyd, yf);
  if(tdy < 0 || tdy > (t - td)) return -1;
  return xf;
}

int main(void) {
  cin >> tf >> vf >> hf >> td >> vd >> hd;
  double lo = td;
  double hi = 1e15;
  double sol = 1e15;
  double mi;

  for(int i = 0; i < 500; ++i) {
    mi = (lo + hi) / 2;
    double x = can(mi);
    if(x < 0) {
      lo = mi;
    } else {
      hi = mi;
    }
    if(x > 0) sol = x / vd + mi;
  }
  
  printf("%.8f\n", sol);

  return 0;
}

