#include <queue>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cstdlib>
#include <vector>
#include <queue>

using namespace std;

typedef long long llint;
typedef pair<int, int> pii;
const int MAXN = 20;

int n, m, k;
char type;
int in_city[20][20];
vector<pii> submasks[1500];
int dp[20][1500];
int dist[MAXN][MAXN];
pii city[MAXN];
int d[MAXN][MAXN];

int solve(int t, int mask) {
  if (mask == 0) return 0;
  int &ref = dp[t][mask];
  if (ref != -1) return ref;
  ref = 1e9; 
  for (auto subms : submasks[mask]) {
    ref = min(ref, solve(t, subms.first) + solve(t, subms.second));
  }
  for (int next = 0; next < k; ++next) {
    if (mask & (1 << next)) {
      ref = min(ref, solve(next, mask ^ (1 << next)) + dist[t][next]);
    }
  }
  return ref;
}

void bfs(int y, int x) {
  memset(d, 1, sizeof d);
  queue<pii> q;
  q.push({y, x});
  d[y][x] = 0;
  while (q.size()) {
    pii t = q.front();
    q.pop();
    int  y = t.first;
    int x = t.second;

    auto expand = [&](int ny, int nx) {
      int nd = d[y][x] + 1;
      if (nd < d[ny][nx]) {
        d[ny][nx] = nd;
        q.push(ny, nx);
      }
    };
  if (type == 'R' || type == 'Q') {
    for (int i = 0; i < n; ++i) {
      expand(i, x);
    }
    for (int i = 0; i < m; ++i) {
      expand(y, i);
    }
  }
  if (type == 'B' || type == 'Q') {
    for (int i = -20; i <= 20; ++i) {
      if (y + i >= 0 && y + i < n && x + i >= 0 && x + i < m) {
        expand(y + i, x + i);
      }
      if (y - i >= 0 && y - i < n && x + i >= 0 && x + i < m) {
        expand(y - i, x + i);
      }
    }
  }
  if (type == 'K') {
    for (int i = -1; i <= 1; ++i) {
      for (int j = -1; j <= 1; ++j) {
        if (y + i >= 0 && y + i < n && x + j >= 0 && x + j < m) {
          expand(y + i, x + j);
        }
      }
    }
  }
  if (type == 'N') {
    for (int i = -2; i <= 2; ++i) {
      for (int j = -2; j <= 2; ++j) {
        int ai = abs(i);
        int aj = abs(j);
        int has1 = ai == 1 || aj == 1;
        int has2 = ai == 2 || aj == 2;
        if (has1 && has2) {
          if (y + i >= 0 && y + i < n && x + j >= 0 && x + j < m) {
            expand(y + i, x + j);
          }
        }
      }
    }
  }
  }
}

int main(void) {
  pii king;
  scanf("%d%d", &n, &m);
  scanf("%d%d %c", &king.first, &king.second, &type);
  --king.first; --king.second;
  scanf("%d", &k);
  memset(in_city, -1, sizeof in_city);
  for (int i = 0; i < k; ++i) {
    scanf("%d%d", &city[i].first, &city[i].second);
    --city[i].first;
    --city[i].second;
  }

  memset(dp, -1, sizeof(dp));
  for (int mask = 0; mask < (1 << k); ++mask) {
    for (int submask = 1; submask < (1 << k); ++submask) {
      if ((submask | mask) == mask) {
        int other_submask = submask ^ mask;
        if (other_submask > submask) continue;
        submasks[mask].emplace_back(submask, other_submask);
      }
    }
  }

  city[k] = king;
  for (int i = 0; i < k + 1; ++i) {
    bfs(city[i].first, city[i].second);
    for (int j = 0; j < k + 1; ++j) {
      dist[i][j] = d[city[j].first][city[j].second];
    }
  }

  int ans = solve(k, (1 << k) - 1);
  if (ans >= 1e9) {
    printf("%d\n", -1);
  } else {
    printf("%d\n", ans);
  }
  return 0;
}

